<template>
  <StackLayout
    v-if="true"
    :width="$responsiveUI.scale(300)"
    paddingBottom="30"
    paddingLeft="15"
    paddingRight="15"
  >
    <Image
      horizontalAlignment="left"
      marginLeft="5"
      marginTop="45"
      src="~/assets/images/drawer_open.png"
      height="20"
      width="20"
    />
    <Image
      marginTop="20"
      src="~/assets/images/logo.png"
      height="40"
      width="auto"
      @tap="$goToScreen('home')"
    />

    <FlexboxLayout
      marginTop="20"
      :height="memberName ? 'auto' : 0"
      width="100%"
      flexDirection="column"
      alignItems="center"
    >
      <Label fontSize="14" color="white" :text="`Welcome, ${memberName}!`" />
    </FlexboxLayout>
    <MenuSelector :selectorWidth="$responsiveUI.scale(300)" selectorHeight="45" />
    <FlexboxLayout
      flexDirection="column"
      alignItems="center"
      width="100%"
      height="auto"
      paddingTop="10"
    >
      <StackLayout width="100%" marginLeft="10" marginRight="10" marginTop="10">
        <SideMenu v-if="menuItemReady" :menuData="menuItems" />
      </StackLayout>
    </FlexboxLayout>
  </StackLayout>
</template>

<script>
import { mapGetters, mapMutations, mapActions } from "vuex";
import HomeScreen from "./HomeScreen";
import ProductList from "../Product/List/Index";
import Account from "../Member/Account";
import Login from "../Member/Login";
import Register from "../Member/Register";
import { GETTERS, MUTATORS, ACTIONS } from "~/store/menu";
import { GETTERS as MEMBER_GETTERS } from "~/store/member";

import MenuSelector from "./MenuSelector";
import SideMenu from "./SideMenu";
export default {
  props: {
    contentFrame: String,
    isShowContent: Boolean
  },
  watch: {
    memberId() {
      this.loadMenuItems(this.memberId);
    },
    menuItems() {
      this.menuItemReady = true;
    },
    isShowContent() {
      console.log("Changed: ", this.isShowContent);
    }
  },
  data() {
    return {
      menuItemReady: false,
    };
  },
  components: {
    MenuSelector,
    SideMenu,
  },
  computed: {
    ...mapGetters({
      memberId: MEMBER_GETTERS.MEMBER_ID,
      memberName: MEMBER_GETTERS.MEMBER_NAME,
      menuItems: GETTERS.MENU_ITEMS,
      countryOptions: GETTERS.DROPDOWN_COUNTRIES,
      languageOptions: GETTERS.DROPDOWN_LANGUAGES,
      currencyOptions: GETTERS.DROPDOWN_CURRENCIES,
      selectedLanguage: GETTERS.SELECTED_LANGUAGE,
      selectedCountry: GETTERS.SELECTED_COUNTRY,
      selectedCurrency: GETTERS.SELECTED_CURRENCY
    }),
    isEnable() {
      return (
        this.countryOptions &&
        this.languageOptions &&
        this.currencyOptions &&
        this.selectedLanguage &&
        this.selectedCountry &&
        this.selectedCurrency
      );
    },
    currencyDropdown() {
      if (this.selectedCurrency) {
        return this.currencyOptions.filter(
          currency => currency.Code === this.selectedCurrency
        );
      }
      return this.currencyOptions;
    }
  },
  mounted() {
    this.loadMenuItems(this.memberId);
    // console.log("MENU width: ", this.$refs.body.nativeView.width);
  },
  methods: {
    ...mapMutations({
      setSelectedOption: MUTATORS.SET_SELECTED
    }),
    ...mapActions({
      loadMenuItems: ACTIONS.LOAD_MENU_ITEMS,
      loadGeoIP: ACTIONS.LOAD_GEOIP_CONFIG
    }),
    onItemCountryChanged(country) {
      this.loadGeoIP(country);
      this.setSelectedOption({ country });
    },
    onItemLanguageChanged(language) {
      this.setSelectedOption({ language });
    },
    onItemCurrencyChanged(currency) {
      this.setSelectedOption({ currency });
    }
  }
};
</script>

<style scoped>
.drawer {
  height: 100%;
  background-color: rgba(0, 0, 0, 0.8);
  border-top-right-radius: 10;
  border-bottom-right-radius: 10;
}

.profile-item-container {
  padding-top: 10;
  padding-bottom: 10;
}

.profile-item-container.border {
  border-top-width: 1;
  border-top-color: #ffffff;
}

.profile-item {
  padding: 5 0;
  color: #ffffff;
  font-size: 12;
  font-family: "Roboto", "Roboto-Light";
  font-weight: 300;
}

.logout-item {
  width: 80%;
  padding: 10 0 10 0;
  margin-bottom: 5;
  color: #ffffff;
  font-size: 12;
}
</style>
